package org.kapelle.multiblock;

import org.bukkit.Location;
import org.bukkit.util.BlockVector;

import java.util.List;

public class MultiblockStructure {

    List<List<List<BlockComponent>>> structure;

    public MultiblockStructure(List<List<List<BlockComponent>>> structure){
        this.structure = structure;
    }

    public BlockComponent getComponent(BlockVector offset){
        return getComponent(offset.getBlockX(),offset.getBlockY(),offset.getBlockZ());
    }

    public BlockComponent getComponent(int x, int y, int z){
        return structure.get(y).get(z).get(x);
    }

    public boolean isValid(Location location, BlockVector offset){
        for (int y = 0; y < structure.size(); y++) {
            for (int z = 0; z < structure.get(y).size(); z++) {
                for (int x = 0; x < structure.get(y).get(z).size() ; x++) {

                    BlockComponent currentComponent = getComponent(x,y,z);
                    Location globalBlockLocation = location.clone().subtract(offset).add(new BlockVector(x,y,z));

                    if(!currentComponent.isValidBlock(globalBlockLocation)){
                        return false;
                    }
                }
            }
        }

        return true;
    }
}
